"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
require("./first");
require("./isEmpty");
const NoSuchElementError_1 = require("../error/NoSuchElementError");
const isFunction_1 = require("../../utility/isFunction");
function findOrThrow(predicate, supply = () => new NoSuchElementError_1.default()) {
    const lambda = isFunction_1.default(predicate) ? predicate : (element) => element === predicate;
    const values = this.filter(value => lambda(value));
    if (values.isEmpty()) {
        throw supply();
    }
    return values.first();
}
exports.default = findOrThrow;
Array.prototype.findOrThrow = findOrThrow;
//# sourceMappingURL=findOrThrow.js.map